/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#include <sstream>

#include <AMQP_ClientProxy.h>
#include <AMQFrame.h>
#include <AccessRequestBody.h>
#include <AccessRequestOkBody.h>
#include <BasicAckBody.h>
#include <BasicCancelBody.h>
#include <BasicCancelOkBody.h>
#include <BasicConsumeBody.h>
#include <BasicConsumeOkBody.h>
#include <BasicDeliverBody.h>
#include <BasicGetBody.h>
#include <BasicGetEmptyBody.h>
#include <BasicGetOkBody.h>
#include <BasicPublishBody.h>
#include <BasicQosBody.h>
#include <BasicQosOkBody.h>
#include <BasicRecoverBody.h>
#include <BasicRejectBody.h>
#include <BasicReturnBody.h>
#include <ChannelAlertBody.h>
#include <ChannelCloseBody.h>
#include <ChannelCloseOkBody.h>
#include <ChannelFlowBody.h>
#include <ChannelFlowOkBody.h>
#include <ChannelOpenBody.h>
#include <ChannelOpenOkBody.h>
#include <ConnectionCloseBody.h>
#include <ConnectionCloseOkBody.h>
#include <ConnectionOpenBody.h>
#include <ConnectionOpenOkBody.h>
#include <ConnectionRedirectBody.h>
#include <ConnectionSecureBody.h>
#include <ConnectionSecureOkBody.h>
#include <ConnectionStartBody.h>
#include <ConnectionStartOkBody.h>
#include <ConnectionTuneBody.h>
#include <ConnectionTuneOkBody.h>
#include <DtxSelectBody.h>
#include <DtxSelectOkBody.h>
#include <DtxStartBody.h>
#include <DtxStartOkBody.h>
#include <ExchangeBoundBody.h>
#include <ExchangeBoundOkBody.h>
#include <ExchangeDeclareBody.h>
#include <ExchangeDeclareOkBody.h>
#include <ExchangeDeleteBody.h>
#include <ExchangeDeleteOkBody.h>
#include <FileAckBody.h>
#include <FileCancelBody.h>
#include <FileCancelOkBody.h>
#include <FileConsumeBody.h>
#include <FileConsumeOkBody.h>
#include <FileDeliverBody.h>
#include <FileOpenBody.h>
#include <FileOpenOkBody.h>
#include <FilePublishBody.h>
#include <FileQosBody.h>
#include <FileQosOkBody.h>
#include <FileRejectBody.h>
#include <FileReturnBody.h>
#include <FileStageBody.h>
#include <QueueBindBody.h>
#include <QueueBindOkBody.h>
#include <QueueDeclareBody.h>
#include <QueueDeclareOkBody.h>
#include <QueueDeleteBody.h>
#include <QueueDeleteOkBody.h>
#include <QueuePurgeBody.h>
#include <QueuePurgeOkBody.h>
#include <StreamCancelBody.h>
#include <StreamCancelOkBody.h>
#include <StreamConsumeBody.h>
#include <StreamConsumeOkBody.h>
#include <StreamDeliverBody.h>
#include <StreamPublishBody.h>
#include <StreamQosBody.h>
#include <StreamQosOkBody.h>
#include <StreamReturnBody.h>
#include <TestContentBody.h>
#include <TestContentOkBody.h>
#include <TestIntegerBody.h>
#include <TestIntegerOkBody.h>
#include <TestStringBody.h>
#include <TestStringOkBody.h>
#include <TestTableBody.h>
#include <TestTableOkBody.h>
#include <TunnelRequestBody.h>
#include <TxCommitBody.h>
#include <TxCommitOkBody.h>
#include <TxRollbackBody.h>
#include <TxRollbackOkBody.h>
#include <TxSelectBody.h>
#include <TxSelectOkBody.h>

namespace qpid {
namespace framing {

AMQP_ClientProxy::AMQP_ClientProxy(OutputHandler* out, u_int8_t major, u_int8_t minor) :
    AMQP_ClientOperations(major, minor),
    version(major, minor),
    out(out),
    access(out, this),
    basic(out, this),
    channel(out, this),
    connection(out, this),
    dtx(out, this),
    exchange(out, this),
    file(out, this),
    queue(out, this),
    stream(out, this),
    test(out, this),
    tunnel(out, this),
    tx(out, this)
        
{}

	// Inner class instance get methods
	
AMQP_ClientProxy::Access& AMQP_ClientProxy::getAccess()
{
    return access;
}

AMQP_ClientProxy::Basic& AMQP_ClientProxy::getBasic()
{
    return basic;
}

AMQP_ClientProxy::Channel& AMQP_ClientProxy::getChannel()
{
    return channel;
}

AMQP_ClientProxy::Connection& AMQP_ClientProxy::getConnection()
{
    return connection;
}

AMQP_ClientProxy::Dtx& AMQP_ClientProxy::getDtx()
{
    return dtx;
}

AMQP_ClientProxy::Exchange& AMQP_ClientProxy::getExchange()
{
    return exchange;
}

AMQP_ClientProxy::File& AMQP_ClientProxy::getFile()
{
    return file;
}

AMQP_ClientProxy::Queue& AMQP_ClientProxy::getQueue()
{
    return queue;
}

AMQP_ClientProxy::Stream& AMQP_ClientProxy::getStream()
{
    return stream;
}

AMQP_ClientProxy::Test& AMQP_ClientProxy::getTest()
{
    return test;
}

AMQP_ClientProxy::Tunnel& AMQP_ClientProxy::getTunnel()
{
    return tunnel;
}

AMQP_ClientProxy::Tx& AMQP_ClientProxy::getTx()
{
    return tx;
}

	// Inner class implementation

// ==================== class Access ====================
void AMQP_ClientProxy::Access::requestOk( u_int16_t channel,
                    u_int16_t ticket )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new AccessRequestOkBody( parent->getProtocolVersion(),
                         ticket )));
}


// ==================== class Basic ====================
void AMQP_ClientProxy::Basic::cancelOk( u_int16_t channel,
                    const string& consumerTag )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicCancelOkBody( parent->getProtocolVersion(),
                         consumerTag )));
}


void AMQP_ClientProxy::Basic::consumeOk( u_int16_t channel,
                    const string& consumerTag )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicConsumeOkBody( parent->getProtocolVersion(),
                         consumerTag )));
}


void AMQP_ClientProxy::Basic::deliver( u_int16_t channel,
                    const string& consumerTag,
                    u_int64_t deliveryTag,
                    bool redelivered,
                    const string& exchange,
                    const string& routingKey )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicDeliverBody( parent->getProtocolVersion(),
                         consumerTag,
                         deliveryTag,
                         redelivered,
                         exchange,
                         routingKey )));
}


void AMQP_ClientProxy::Basic::getEmpty( u_int16_t channel,
                    const string& clusterId )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicGetEmptyBody( parent->getProtocolVersion(),
                         clusterId )));
}


void AMQP_ClientProxy::Basic::getOk( u_int16_t channel,
                    u_int64_t deliveryTag,
                    bool redelivered,
                    const string& exchange,
                    const string& routingKey,
                    u_int32_t messageCount )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicGetOkBody( parent->getProtocolVersion(),
                         deliveryTag,
                         redelivered,
                         exchange,
                         routingKey,
                         messageCount )));
}


void AMQP_ClientProxy::Basic::qosOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicQosOkBody( parent->getProtocolVersion() )));
}


void AMQP_ClientProxy::Basic::return_( u_int16_t channel,
                    u_int16_t replyCode,
                    const string& replyText,
                    const string& exchange,
                    const string& routingKey )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicReturnBody( parent->getProtocolVersion(),
                         replyCode,
                         replyText,
                         exchange,
                         routingKey )));
}


// ==================== class Channel ====================
void AMQP_ClientProxy::Channel::alert( u_int16_t channel,
                    u_int16_t replyCode,
                    const string& replyText,
                    const FieldTable& details )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ChannelAlertBody( parent->getProtocolVersion(),
                         replyCode,
                         replyText,
                         details )));
}


void AMQP_ClientProxy::Channel::close( u_int16_t channel,
                    u_int16_t replyCode,
                    const string& replyText,
                    u_int16_t classId,
                    u_int16_t methodId )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ChannelCloseBody( parent->getProtocolVersion(),
                         replyCode,
                         replyText,
                         classId,
                         methodId )));
}


void AMQP_ClientProxy::Channel::closeOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ChannelCloseOkBody( parent->getProtocolVersion() )));
}


void AMQP_ClientProxy::Channel::flow( u_int16_t channel,
                    bool active )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ChannelFlowBody( parent->getProtocolVersion(),
                         active )));
}


void AMQP_ClientProxy::Channel::flowOk( u_int16_t channel,
                    bool active )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ChannelFlowOkBody( parent->getProtocolVersion(),
                         active )));
}


void AMQP_ClientProxy::Channel::openOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ChannelOpenOkBody( parent->getProtocolVersion() )));
}


// ==================== class Connection ====================
void AMQP_ClientProxy::Connection::close( u_int16_t channel,
                    u_int16_t replyCode,
                    const string& replyText,
                    u_int16_t classId,
                    u_int16_t methodId )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionCloseBody( parent->getProtocolVersion(),
                         replyCode,
                         replyText,
                         classId,
                         methodId )));
}


void AMQP_ClientProxy::Connection::closeOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionCloseOkBody( parent->getProtocolVersion() )));
}


void AMQP_ClientProxy::Connection::openOk( u_int16_t channel,
                    const string& knownHosts )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionOpenOkBody( parent->getProtocolVersion(),
                         knownHosts )));
}


void AMQP_ClientProxy::Connection::redirect( u_int16_t channel,
                    const string& host,
                    const string& knownHosts )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionRedirectBody( parent->getProtocolVersion(),
                         host,
                         knownHosts )));
}


void AMQP_ClientProxy::Connection::secure( u_int16_t channel,
                    const string& challenge )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionSecureBody( parent->getProtocolVersion(),
                         challenge )));
}


void AMQP_ClientProxy::Connection::start( u_int16_t channel,
                    u_int8_t versionMajor,
                    u_int8_t versionMinor,
                    const FieldTable& serverProperties,
                    const string& mechanisms,
                    const string& locales )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionStartBody( parent->getProtocolVersion(),
                         versionMajor,
                         versionMinor,
                         serverProperties,
                         mechanisms,
                         locales )));
}


void AMQP_ClientProxy::Connection::tune( u_int16_t channel,
                    u_int16_t channelMax,
                    u_int32_t frameMax,
                    u_int16_t heartbeat )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionTuneBody( parent->getProtocolVersion(),
                         channelMax,
                         frameMax,
                         heartbeat )));
}


// ==================== class Dtx ====================
void AMQP_ClientProxy::Dtx::selectOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new DtxSelectOkBody( parent->getProtocolVersion() )));
}


void AMQP_ClientProxy::Dtx::startOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new DtxStartOkBody( parent->getProtocolVersion() )));
}


// ==================== class Exchange ====================
void AMQP_ClientProxy::Exchange::declareOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ExchangeDeclareOkBody( parent->getProtocolVersion() )));
}


void AMQP_ClientProxy::Exchange::deleteOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ExchangeDeleteOkBody( parent->getProtocolVersion() )));
}


// ==================== class File ====================
void AMQP_ClientProxy::File::cancelOk( u_int16_t channel,
                    const string& consumerTag )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileCancelOkBody( parent->getProtocolVersion(),
                         consumerTag )));
}


void AMQP_ClientProxy::File::consumeOk( u_int16_t channel,
                    const string& consumerTag )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileConsumeOkBody( parent->getProtocolVersion(),
                         consumerTag )));
}


void AMQP_ClientProxy::File::deliver( u_int16_t channel,
                    const string& consumerTag,
                    u_int64_t deliveryTag,
                    bool redelivered,
                    const string& exchange,
                    const string& routingKey,
                    const string& identifier )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileDeliverBody( parent->getProtocolVersion(),
                         consumerTag,
                         deliveryTag,
                         redelivered,
                         exchange,
                         routingKey,
                         identifier )));
}


void AMQP_ClientProxy::File::open( u_int16_t channel,
                    const string& identifier,
                    u_int64_t contentSize )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileOpenBody( parent->getProtocolVersion(),
                         identifier,
                         contentSize )));
}


void AMQP_ClientProxy::File::openOk( u_int16_t channel,
                    u_int64_t stagedSize )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileOpenOkBody( parent->getProtocolVersion(),
                         stagedSize )));
}


void AMQP_ClientProxy::File::qosOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileQosOkBody( parent->getProtocolVersion() )));
}


void AMQP_ClientProxy::File::return_( u_int16_t channel,
                    u_int16_t replyCode,
                    const string& replyText,
                    const string& exchange,
                    const string& routingKey )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileReturnBody( parent->getProtocolVersion(),
                         replyCode,
                         replyText,
                         exchange,
                         routingKey )));
}


void AMQP_ClientProxy::File::stage( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileStageBody( parent->getProtocolVersion() )));
}


// ==================== class Queue ====================
void AMQP_ClientProxy::Queue::bindOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new QueueBindOkBody( parent->getProtocolVersion() )));
}


void AMQP_ClientProxy::Queue::declareOk( u_int16_t channel,
                    const string& queue,
                    u_int32_t messageCount,
                    u_int32_t consumerCount )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new QueueDeclareOkBody( parent->getProtocolVersion(),
                         queue,
                         messageCount,
                         consumerCount )));
}


void AMQP_ClientProxy::Queue::deleteOk( u_int16_t channel,
                    u_int32_t messageCount )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new QueueDeleteOkBody( parent->getProtocolVersion(),
                         messageCount )));
}


void AMQP_ClientProxy::Queue::purgeOk( u_int16_t channel,
                    u_int32_t messageCount )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new QueuePurgeOkBody( parent->getProtocolVersion(),
                         messageCount )));
}


// ==================== class Stream ====================
void AMQP_ClientProxy::Stream::cancelOk( u_int16_t channel,
                    const string& consumerTag )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new StreamCancelOkBody( parent->getProtocolVersion(),
                         consumerTag )));
}


void AMQP_ClientProxy::Stream::consumeOk( u_int16_t channel,
                    const string& consumerTag )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new StreamConsumeOkBody( parent->getProtocolVersion(),
                         consumerTag )));
}


void AMQP_ClientProxy::Stream::deliver( u_int16_t channel,
                    const string& consumerTag,
                    u_int64_t deliveryTag,
                    const string& exchange,
                    const string& queue )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new StreamDeliverBody( parent->getProtocolVersion(),
                         consumerTag,
                         deliveryTag,
                         exchange,
                         queue )));
}


void AMQP_ClientProxy::Stream::qosOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new StreamQosOkBody( parent->getProtocolVersion() )));
}


void AMQP_ClientProxy::Stream::return_( u_int16_t channel,
                    u_int16_t replyCode,
                    const string& replyText,
                    const string& exchange,
                    const string& routingKey )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new StreamReturnBody( parent->getProtocolVersion(),
                         replyCode,
                         replyText,
                         exchange,
                         routingKey )));
}


// ==================== class Test ====================
void AMQP_ClientProxy::Test::content( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestContentBody( parent->getProtocolVersion() )));
}


void AMQP_ClientProxy::Test::contentOk( u_int16_t channel,
                    u_int32_t contentChecksum )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestContentOkBody( parent->getProtocolVersion(),
                         contentChecksum )));
}


void AMQP_ClientProxy::Test::integer( u_int16_t channel,
                    u_int8_t integer1,
                    u_int16_t integer2,
                    u_int32_t integer3,
                    u_int64_t integer4,
                    u_int8_t operation )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestIntegerBody( parent->getProtocolVersion(),
                         integer1,
                         integer2,
                         integer3,
                         integer4,
                         operation )));
}


void AMQP_ClientProxy::Test::integerOk( u_int16_t channel,
                    u_int64_t result )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestIntegerOkBody( parent->getProtocolVersion(),
                         result )));
}


void AMQP_ClientProxy::Test::string_( u_int16_t channel,
                    const string& string1,
                    const string& string2,
                    u_int8_t operation )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestStringBody( parent->getProtocolVersion(),
                         string1,
                         string2,
                         operation )));
}


void AMQP_ClientProxy::Test::stringOk( u_int16_t channel,
                    const string& result )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestStringOkBody( parent->getProtocolVersion(),
                         result )));
}


void AMQP_ClientProxy::Test::table( u_int16_t channel,
                    const FieldTable& table,
                    u_int8_t integerOp,
                    u_int8_t stringOp )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestTableBody( parent->getProtocolVersion(),
                         table,
                         integerOp,
                         stringOp )));
}


void AMQP_ClientProxy::Test::tableOk( u_int16_t channel,
                    u_int64_t integerResult,
                    const string& stringResult )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestTableOkBody( parent->getProtocolVersion(),
                         integerResult,
                         stringResult )));
}


// ==================== class Tunnel ====================

// ==================== class Tx ====================
void AMQP_ClientProxy::Tx::commitOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TxCommitOkBody( parent->getProtocolVersion() )));
}


void AMQP_ClientProxy::Tx::rollbackOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TxRollbackOkBody( parent->getProtocolVersion() )));
}


void AMQP_ClientProxy::Tx::selectOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TxSelectOkBody( parent->getProtocolVersion() )));
}


} /* namespace framing */
} /* namespace qpid */
