/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_BasicCancelBody__
#define qpid_framing_BasicCancelBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class BasicCancelBody : public AMQMethodBody
{
	// Method field declarations

    string consumerTag;
    bool nowait;
     

public:
    typedef boost::shared_ptr<BasicCancelBody> shared_ptr;

	// Constructors and destructors

    BasicCancelBody(ProtocolVersion& version,
        const string& consumerTag,
        bool nowait
        ) :
        AMQMethodBody(version),
        consumerTag(consumerTag),
        nowait(nowait)
    { }


    inline BasicCancelBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline BasicCancelBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~BasicCancelBody() {}
    
    // Attribute get methods

    inline const string& getConsumerTag() { return consumerTag; }
    inline bool getNowait() { return nowait; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "BasicCancel: ";
        out << "consumerTag=" << consumerTag;
        out << "; nowait=" << nowait;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 60;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 30;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1 + consumerTag.length(); /* consumerTag: shortstr */
        size += 1; /* nowait: bit */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShortString(consumerTag); /* consumerTag: shortstr */
        u_int8_t flags_1[1] = {0};
        flags_1[0] |= nowait << 0; /* nowait: bit */
        buffer.putOctet(flags_1[0]);
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getShortString(consumerTag); /* consumerTag: shortstr */
        u_int8_t flags_1[1];
        flags_1[0] = buffer.getOctet();
        nowait = (1 << 0) & flags_1[0]; /* nowait: bit */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getBasicHandler()->cancel(channel,
                    consumerTag,
                    nowait
                    );
    }


}; // class BasicCancelBody


} // namespace framing
} // namespace qpid

#endif

