/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_ConnectionStartOkBody__
#define qpid_framing_ConnectionStartOkBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class ConnectionStartOkBody : public AMQMethodBody
{
	// Method field declarations

    FieldTable clientProperties;
    string mechanism;
    string response;
    string locale;
     

public:
    typedef boost::shared_ptr<ConnectionStartOkBody> shared_ptr;

	// Constructors and destructors

    ConnectionStartOkBody(ProtocolVersion& version,
        const FieldTable& clientProperties,
        const string& mechanism,
        const string& response,
        const string& locale
        ) :
        AMQMethodBody(version),
        clientProperties(clientProperties),
        mechanism(mechanism),
        response(response),
        locale(locale)
    { }


    inline ConnectionStartOkBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline ConnectionStartOkBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~ConnectionStartOkBody() {}
    
    // Attribute get methods

    inline const FieldTable& getClientProperties() { return clientProperties; }
    inline const string& getMechanism() { return mechanism; }
    inline const string& getResponse() { return response; }
    inline const string& getLocale() { return locale; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "ConnectionStartOk: ";
        out << "clientProperties=" << clientProperties;
        out << "; mechanism=" << mechanism;
        out << "; response=" << response;
        out << "; locale=" << locale;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 10;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 11;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += clientProperties.size(); /* clientProperties: table */
        size += 1 + mechanism.length(); /* mechanism: shortstr */
        size += 4 + response.length(); /* response: longstr */
        size += 1 + locale.length(); /* locale: shortstr */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putFieldTable(clientProperties); /* clientProperties: table */
        buffer.putShortString(mechanism); /* mechanism: shortstr */
        buffer.putLongString(response); /* response: longstr */
        buffer.putShortString(locale); /* locale: shortstr */
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getFieldTable(clientProperties); /* clientProperties: table */
        buffer.getShortString(mechanism); /* mechanism: shortstr */
        buffer.getLongString(response); /* response: longstr */
        buffer.getShortString(locale); /* locale: shortstr */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getConnectionHandler()->startOk(channel,
                    clientProperties,
                    mechanism,
                    response,
                    locale
                    );
    }


}; // class ConnectionStartOkBody


} // namespace framing
} // namespace qpid

#endif

