/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_QueueDeclareOkBody__
#define qpid_framing_QueueDeclareOkBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class QueueDeclareOkBody : public AMQMethodBody
{
	// Method field declarations

    string queue;
    u_int32_t messageCount;
    u_int32_t consumerCount;
     

public:
    typedef boost::shared_ptr<QueueDeclareOkBody> shared_ptr;

	// Constructors and destructors

    QueueDeclareOkBody(ProtocolVersion& version,
        const string& queue,
        u_int32_t messageCount,
        u_int32_t consumerCount
        ) :
        AMQMethodBody(version),
        queue(queue),
        messageCount(messageCount),
        consumerCount(consumerCount)
    { }


    inline QueueDeclareOkBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline QueueDeclareOkBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~QueueDeclareOkBody() {}
    
    // Attribute get methods

    inline const string& getQueue() { return queue; }
    inline u_int32_t getMessageCount() { return messageCount; }
    inline u_int32_t getConsumerCount() { return consumerCount; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "QueueDeclareOk: ";
        out << "queue=" << queue;
        out << "; messageCount=" << messageCount;
        out << "; consumerCount=" << consumerCount;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 50;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 11;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1 + queue.length(); /* queue: shortstr */
        size += 4; /* messageCount: long */
        size += 4; /* consumerCount: long */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShortString(queue); /* queue: shortstr */
        buffer.putLong(messageCount); /* messageCount: long */
        buffer.putLong(consumerCount); /* consumerCount: long */
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getShortString(queue); /* queue: shortstr */
        messageCount = buffer.getLong(); /* messageCount: long */
        consumerCount = buffer.getLong(); /* consumerCount: long */
    }       



}; // class QueueDeclareOkBody


} // namespace framing
} // namespace qpid

#endif

