/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_TestIntegerBody__
#define qpid_framing_TestIntegerBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class TestIntegerBody : public AMQMethodBody
{
	// Method field declarations

    u_int8_t integer1;
    u_int16_t integer2;
    u_int32_t integer3;
    u_int64_t integer4;
    u_int8_t operation;
     

public:
    typedef boost::shared_ptr<TestIntegerBody> shared_ptr;

	// Constructors and destructors

    TestIntegerBody(ProtocolVersion& version,
        u_int8_t integer1,
        u_int16_t integer2,
        u_int32_t integer3,
        u_int64_t integer4,
        u_int8_t operation
        ) :
        AMQMethodBody(version),
        integer1(integer1),
        integer2(integer2),
        integer3(integer3),
        integer4(integer4),
        operation(operation)
    { }


    inline TestIntegerBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline TestIntegerBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~TestIntegerBody() {}
    
    // Attribute get methods

    inline u_int8_t getInteger1() { return integer1; }
    inline u_int16_t getInteger2() { return integer2; }
    inline u_int32_t getInteger3() { return integer3; }
    inline u_int64_t getInteger4() { return integer4; }
    inline u_int8_t getOperation() { return operation; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "TestInteger: ";
        out << "integer1=" << (int)integer1;
        out << "; integer2=" << integer2;
        out << "; integer3=" << integer3;
        out << "; integer4=" << integer4;
        out << "; operation=" << (int)operation;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 120;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 10;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1; /* integer1: octet */
        size += 2; /* integer2: short */
        size += 4; /* integer3: long */
        size += 8; /* integer4: longlong */
        size += 1; /* operation: octet */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putOctet(integer1); /* integer1: octet */
        buffer.putShort(integer2); /* integer2: short */
        buffer.putLong(integer3); /* integer3: long */
        buffer.putLongLong(integer4); /* integer4: longlong */
        buffer.putOctet(operation); /* operation: octet */
    }

    inline void decodeContent(Buffer& buffer)
    {
        integer1 = buffer.getOctet(); /* integer1: octet */
        integer2 = buffer.getShort(); /* integer2: short */
        integer3 = buffer.getLong(); /* integer3: long */
        integer4 = buffer.getLongLong(); /* integer4: longlong */
        operation = buffer.getOctet(); /* operation: octet */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getTestHandler()->integer(channel,
                    integer1,
                    integer2,
                    integer3,
                    integer4,
                    operation
                    );
    }


}; // class TestIntegerBody


} // namespace framing
} // namespace qpid

#endif

